//Written by Minghao Wei, 3rd June 2016 for Technologic Systems
//This is code written for testing ADC24 API
//This code will also be an example showing how to use the API
//This code should covered all most function in the API
#include <stdio.h>
#include <stdint.h>
#include <errno.h>
#include <sys/select.h>
#include <sys/time.h>

#include "adc24.h"

#define PC104BASE 0x80008000//depend on your SBC
#define ADCBASE 0x120//depend on jumper status

//Jumper status:
//JP1 off, JP2 off, IO Base Address 0x100
//JP1 on , JP2 off, IO Base Address 0x120
//JP1 off, JP2 on , IO Base Address 0x140
//JP1 on , JP2 on , IO Base Address 0x160

volatile uint16_t *adc24;//pointer to adc base address
int main(){
        struct adcFIFO temp;
        adc24 = adcSetup(ADCBASE, PC104BASE);//setup pointer
        setClockSpeed(adc24, 50000);//set clock speed
        setInterrupt(adc24, 256);//set interrupt level
        adcStart(adc24, 2);//start state machine
        int i;
        for(i = 0; i < 100; i++){//read 100 sample
                temp = readFIFO(adc24);
                printf("Count: %d, head: %d\n", getFIFOcount(adc24), getHeadChannel(adc24));
                printf("chip: %d, channel: %d, data 0x%x\n", temp.chip, temp.channel, temp.data);
                //printf("data read 0x%x\n", readFIFO_Data(adc24));
        }
        adcStop(adc24);//stop state machine
        cleanFIFO(adc24);//clean FIFO
        getBoardInfor(adc24);//display board information
        return 1;
}

